﻿using log4net;
using log4net.Appender;
using log4net.Layout;
using log4net.Repository.Hierarchy;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BaiduYunSync
{
    class LogSettings
    {
        static LogSettings()
        {
            string LOG_PATTERN = "%d [%t] %-5p %c [%x] - %m%n";
            string LOG_FILE_PATH = "log/job.log";
            Hierarchy hierarchy = (Hierarchy)LogManager.GetRepository();
            hierarchy.Name = "stdAdapter";
            TraceAppender tracer = new TraceAppender();

            PatternLayout patternLayout = new PatternLayout();
            patternLayout.ConversionPattern = LOG_PATTERN;
            patternLayout.ActivateOptions();

            tracer.Layout = patternLayout;
            tracer.ActivateOptions();
            hierarchy.Root.AddAppender(tracer);

            RollingFileAppender roller = new RollingFileAppender();
            roller.Layout = patternLayout;
            roller.AppendToFile = true;
            roller.RollingStyle = RollingFileAppender.RollingMode.Size;
            roller.MaxSizeRollBackups = 10;
            roller.MaximumFileSize = "1MB";
            roller.StaticLogFileName = true;
            roller.File = LOG_FILE_PATH;
            roller.ActivateOptions();
            hierarchy.Root.AddAppender(roller);
            hierarchy.Root.Level = log4net.Core.Level.All;
            hierarchy.Configured = true;
        }

        public static void StdInfo(string msg)
        {
            LogManager.GetLogger("stdAdapter").Info(msg);
        }
    }
}
