﻿using NetDisk;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace BaiduYunSync
{
    public partial class frmLogin : Form
    {
        public frmLogin()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 返回内容
        /// </summary>
        public LoginResult result;

        private LoginCheckResult lcr;

        private void txtUserName_Leave(object sender, EventArgs e)
        {
            if (txtUserName.Text == "")
            {
                lcr = null;
                return;
            }
            lcr = Authentication.LoginCheck(txtUserName.Text);
            if (!lcr.success)
            {
                MessageBox.Show("错误：" + lcr.exception);
                return;
            }
            lbVcode.Visible = txtVCode.Visible = pbVcode.Visible = lcr.needVCode;
            txtVCode.Text = "";
            if (lcr.needVCode)
            {
                pbVcode.Image = ByteToImage(lcr.image);
            }
        }

        private static Bitmap ByteToImage(byte[] blob)
        {
            MemoryStream mStream = new MemoryStream();
            byte[] pData = blob;
            mStream.Write(pData, 0, Convert.ToInt32(pData.Length));
            Bitmap bm = new Bitmap(mStream, false);
            mStream.Dispose();
            return bm;
        }

        private void frmLogin_Load(object sender, EventArgs e)
        {
            txtUserName.Focus();
        }

        private void btnLogin_Click(object sender, EventArgs e)
        {
            if (lcr == null) return;
            lcr.verifyCode = txtVCode.Text;
            result = Authentication.Login(txtUserName.Text, txtPassword.Text, lcr);
            if (!result.success)
            {
                MessageBox.Show("出现错误: " + result.exception);
                txtUserName_Leave(null, null);
                return;
            }
            var userInfo = LiteDbHelper.UserInfo;
            userInfo.UserName = txtUserName.Text;
            userInfo.UserCredentialStr = result.credential.Serialize();
            LiteDbHelper.UserInfo = userInfo;
            DialogResult = DialogResult.OK;
        }

        private void pbVcode_Click(object sender, EventArgs e)
        {
            txtUserName_Leave(null, null);
        }

        private void frmLogin_FormClosing(object sender, FormClosingEventArgs e)
        {
        }
    }
}
